## vulkan-validationlayers 1.1.82.0

=== debian/changelog ===
vulkan-validationlayers (1.1.82.0-0ubuntu1) cosmic; urgency=medium

  * Sync from Debian.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 21 Sep 2018 14:47:34 +0300

vulkan-validationlayers (1.1.82.0-1) experimental; urgency=medium

  * Initial packaging, split from old src:vulkan.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 21 Sep 2018 12:46:07 +0300
