=== debian/watch ===
version=4
opts="repack,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/vulkan-validationlayers-$1.tar.gz/" \
 https://github.com/KhronosGroup/Vulkan-ValidationLayers/tags (?:.*?/)sdk[_-](\d[\d.]*)\.tar\.gz
