## vulkan-validationlayers 1.1.97

=== debian/changelog ===
vulkan-validationlayers (1.1.97-2) unstable; urgency=medium

  * copyright: Updated. (Closes: #919686)

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 19 Jan 2019 10:14:16 +0200

vulkan-validationlayers (1.1.97-1) experimental; urgency=medium

  * New upstream release.
  * watch: Use new tag naming.
  * control: Bump libvulkan-dev, glslang-dev and spirv-tools build-deps.
  * use-mxgot-for-mips64.patch: Dropped, upstream.
  * fix_shared.patch: Refreshed.

 -- Timo Aaltonen <tjaalton@debian.org>  Sun, 13 Jan 2019 20:06:28 +0200
