=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper (>= 11),
  cmake,
- glslang-dev,
- libvulkan-dev (>= 1.1.82.0),
+ glslang-dev (>= 7.10.2984),
+ libvulkan-dev (>= 1.1.97),
  libwayland-dev,
  libx11-dev,
  libxrandr-dev,
  pkg-config,
  python3,
- spirv-tools,
+ spirv-tools (>= 2019.1),
 Standards-Version: 4.2.0
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-ValidationLayers
