## vulkan-validationlayers 1.1.101.0

=== debian/changelog ===
vulkan-validationlayers (1.1.101.0-1) unstable; urgency=medium

  * New upstream release.
  * watch: Use proper tag names.
  * control: Bump glslang-dev and spirv-tools build-depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 12 Mar 2019 11:37:05 +0200
