=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper (>= 11),
  cmake,
- glslang-dev (>= 7.10.2984),
+ glslang-dev (>= 7.11.3113),
  libvulkan-dev (>= 1.1.97),
  libwayland-dev,
  libx11-dev,
  libxrandr-dev,
  pkg-config,
  python3,
- spirv-tools (>= 2019.1),
+ spirv-tools (>= 2019.2),
 Standards-Version: 4.2.0
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-ValidationLayers
