## vulkan-validationlayers 1.1.126.0

=== debian/changelog ===
vulkan-validationlayers (1.1.126.0-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 23 Mar 2020 22:06:53 -0700

vulkan-validationlayers (1.1.126.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump build-deps on libvulkan-dev, spirv-tools.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 20 Nov 2019 16:08:33 +0200

vulkan-validationlayers (1.1.114.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.
  * control: Bump glslang-dev and spirv-tools build-deps.
  * rules: Set BUILD_LAYER_SUPPORT_FILES=ON to build headers in this
    version.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 11 Sep 2019 15:32:23 +0300
