=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: vulkan-validationlayers
 Priority: optional
-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper (>= 11),
  cmake,
- glslang-dev (>= 7.11.3113),
- libvulkan-dev (>= 1.1.97),
+ glslang-dev (>= 7.12.3352),
+ libvulkan-dev (>= 1.1.126.0),
  libwayland-dev,
  libx11-dev,
  libxrandr-dev,
  pkg-config,
  python3,
- spirv-tools (>= 2019.2),
+ spirv-tools (>= 2019.4+git20191022),
 Standards-Version: 4.2.0
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-ValidationLayers
